web/tools/run.sh

148 lines
2.6 KiB
Bash
Raw Normal View History

2019-09-30 15:38:41 +03:00
#!/bin/bash
2019-11-05 12:18:31 +03:00
2019-09-30 15:38:41 +03:00
# Run jekyll site at http://127.0.0.1:4000
2019-11-05 12:18:31 +03:00
#
# Requirement:
# Option '-r, --realtime' needs fswatch http://emcrisostomo.github.io/fswatch/
2019-11-05 12:18:31 +03:00
#
2020-01-02 16:17:49 +03:00
# v2.0
# https://github.com/cotes2020/jekyll-theme-chirpy
2019-09-30 15:38:41 +03:00
# © 2019 Cotes Chung
# Published under MIT License
2020-01-01 20:21:43 +03:00
set -eu
WORK_DIR=$(dirname $(dirname $(realpath "$0")))
2019-09-30 15:38:41 +03:00
2019-11-05 12:18:31 +03:00
CONTAINER=.container
SYNC_TOOL=_scripts/sh/sync_monitor.sh
cmd="bundle exec jekyll s"
realtime=false
2019-11-05 12:18:31 +03:00
2020-01-01 20:21:43 +03:00
2020-04-09 22:15:51 +03:00
_help() {
2019-11-05 12:18:31 +03:00
echo "Usage:"
echo
echo " bash run.sh [options]"
echo
echo "Options:"
echo " -H, --host <HOST> Host to bind to"
echo " -P, --port <PORT> Port to listen on"
echo " -b, --baseurl <URL> The site relative url that start with slash, e.g. '/project'"
echo " -h, --help Print the help information"
echo " -t, --trace Show the full backtrace when an error occurs"
echo " -r, --realtime Make the modified content updated in real time"
2019-09-30 15:38:41 +03:00
}
2020-04-09 22:15:51 +03:00
_cleanup() {
2020-02-17 17:54:30 +03:00
if [[ -d _site || -d .jekyll-cache ]]; then
jekyll clean
fi
2020-01-01 20:21:43 +03:00
rm -rf ${WORK_DIR}/${CONTAINER}
2019-11-05 12:18:31 +03:00
ps aux | grep fswatch | awk '{print $2}' | xargs kill -9 > /dev/null 2>&1
2019-09-30 15:38:41 +03:00
}
2020-04-09 22:15:51 +03:00
_init() {
2019-09-30 15:38:41 +03:00
2020-01-01 20:21:43 +03:00
if [[ -d ${WORK_DIR}/${CONTAINER} ]]; then
rm -rf ${WORK_DIR}/${CONTAINER}
2019-09-30 15:38:41 +03:00
fi
2019-09-30 22:38:36 +03:00
temp=$(mktemp -d)
2020-01-01 20:21:43 +03:00
cp -r ${WORK_DIR}/* $temp
cp -r ${WORK_DIR}/.git $temp
mv $temp ${WORK_DIR}/${CONTAINER}
2019-09-30 15:38:41 +03:00
2020-04-09 22:15:51 +03:00
trap _cleanup INT
2019-09-30 15:38:41 +03:00
}
2020-04-09 22:15:51 +03:00
_check_unset() {
2019-11-05 12:18:31 +03:00
if [[ -z ${1:+unset} ]]; then
2020-04-09 22:15:51 +03:00
_help
2019-09-30 15:38:41 +03:00
exit 1
fi
}
2020-04-09 22:15:51 +03:00
_check_command() {
if [[ -z $(command -v $1) ]]; then
echo "Error: command '$1' not found !"
echo "Hint: Get '$1' on <$2>"
exit 1
fi
}
2019-11-05 12:18:31 +03:00
main() {
2020-04-09 22:15:51 +03:00
_init
2019-11-05 12:18:31 +03:00
2020-01-01 20:21:43 +03:00
cd ${WORK_DIR}/${CONTAINER}
2020-04-09 22:15:51 +03:00
bash _scripts/sh/create_pages.sh
bash _scripts/sh/dump_lastmod.sh
if [[ $realtime = true ]]; then
fswatch -0 -e "\\$CONTAINER" -e "\.git" ${WORK_DIR} | xargs -0 -I {} bash ./${SYNC_TOOL} {} $WORK_DIR . &
fi
2019-11-05 12:18:31 +03:00
echo "\$ $cmd"
eval $cmd
}
2019-09-30 15:38:41 +03:00
while (( $# ))
do
opt="$1"
case $opt in
-H|--host)
2020-04-09 22:15:51 +03:00
_check_unset $2
2019-09-30 15:38:41 +03:00
cmd+=" -H $2"
shift # past argument
shift # past value
;;
-P|--port)
2020-04-09 22:15:51 +03:00
_check_unset $2
2019-09-30 15:38:41 +03:00
cmd+=" -P $2"
shift
shift
;;
-b|--baseurl)
2020-04-09 22:15:51 +03:00
_check_unset $2
2019-09-30 15:38:41 +03:00
if [[ $2 == \/* ]]
then
cmd+=" -b $2"
else
2020-04-09 22:15:51 +03:00
_help
2019-09-30 15:38:41 +03:00
exit 1
fi
shift
shift
;;
2019-11-05 12:18:31 +03:00
-t|--trace)
cmd+=" -t"
shift
;;
-r|--realtime)
2020-04-09 22:15:51 +03:00
_check_command fswatch 'http://emcrisostomo.github.io/fswatch/'
realtime=true
shift
;;
2019-09-30 15:38:41 +03:00
-h|--help)
2020-04-09 22:15:51 +03:00
_help
2019-09-30 15:38:41 +03:00
exit 0
;;
*)
# unknown option
2020-04-09 22:15:51 +03:00
_help
2019-09-30 15:38:41 +03:00
exit 1
;;
esac
done
2020-04-09 22:15:51 +03:00
2019-11-05 12:18:31 +03:00
main